package com.networksByteDesign.util;

import java.io.BufferedInputStream;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import org.apache.tools.ant.BuildEvent;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.listener.MailLogger;
import org.apache.tools.ant.util.StringUtils;

public class EncryptedMailLogger extends MailLogger
{
    public void buildFinished(BuildEvent event)
    {
        String encryptedBuffer = encrypt(buffer_.toString());
        super.log(encryptedBuffer);
        super.buildFinished(event);
    }
    
    /**
     *  Receives and buffers log messages.
     *
     * @param message the message being logged
     */
    protected void log(String message)
    {
        buffer_.append(message).append(StringUtils.LINE_SEP);
    }
    
    private String encrypt(String message)
    {
        StringBuffer result  = new StringBuffer(100);
        int          buflen  = 128;
        int          numRead = 0;
        byte[]       buf     = new byte[buflen];
        String       cmd     = "gpg -e -a -r cronus";
        Runtime      rt      = Runtime.getRuntime();
        try
        {
            Process proc = rt.exec(cmd);
            StringBuffer sBuffer = new StringBuffer();
            
            BufferedWriter out =
                new BufferedWriter
                (new OutputStreamWriter(proc.getOutputStream()));

            out.write(message, 0, message.length());
            out.close();
      
            BufferedInputStream bstrm =
                new BufferedInputStream(proc.getInputStream());
            while ((numRead = bstrm.read(buf, 0, buflen)) != -1)
            {
                String line = new String(buf, 0, numRead);
                result.append(line);
            }
        }
        catch (IOException e)
        {
            System.err.println(e.getMessage());
        }

        return result.toString();
    }
    
    /** Buffer in which the message is constructed prior to sending */
    private StringBuffer buffer_ = new StringBuffer();
}
