package com.networksByteDesign.util;

import net.firstpartners.nounit.ui.common.CommandPackage;
import net.firstpartners.nounit.ui.common.Processor;
import net.firstpartners.nounit.utility.NoUnitException;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

public class NoUnitTask extends Task
{
    public void execute()
    {
        if(startDir_ == null || startDir_.trim().length() == 0)
        {
            throw new BuildException
                ("Required attribute startDir not set in noUnit",
                 location);
        }
        
        if(outputDir_ == null || outputDir_.trim().length() == 0)
        {
            throw new BuildException
                ("Required attribute outputDir not set in noUnit",
                 location);
        }
        
        if(reportName_ == null || reportName_.trim().length() == 0)
        {
            throw new BuildException
                ("Required attribute reportName not set in noUnit",
                 location);
        }
        
        if(outputFile_ == null || outputFile_.trim().length() == 0)
        {
            throw new BuildException
                ("Required attribute outputFile not set in noUnit",
                 location);
        }
        
        String args[] = new String[10];
        
        args[0] = "start_dir";
        args[1] = startDir_;
        args[2] = "output_dir";
        args[3] = outputDir_;
        args[4] = "report_class";
        args[5] = "com.networksByteDesign.util.NoUnitReport";
        args[6] = "report_name";
        args[7] = reportName_;
        args[8] = "output_file";
        args[9] = outputFile_;
        
        try
        {
            CommandPackage userArgs = new CommandPackage(args);
            Processor mainProcessor = new Processor();
            CommandPackage results = mainProcessor.transform(userArgs);
        }
        catch(NoUnitException e)
        {
            throw new BuildException(e);
        }
    }
    
    public void setStartDir(String startDir)
    {
        startDir_ = startDir;
    }
    
    public void setOutputDir(String outputDir)
    {
        outputDir_ = outputDir;
    }
    
    public void setReportName(String reportName)
    {
        reportName_ = reportName;
    }
    
    public void setOutputFile(String outputFile)
    {
        outputFile_ = outputFile;
    }
    
    private String startDir_   = null;
    private String outputDir_  = null;
    private String reportName_ = null;
    private String outputFile_ = null;
}
